\section{Symmetric Encryption and Key Exchange}

\subsection{Cryptography Concepts}

\begin{description}
	\item[Message or plaintext] \hfill \\
	Before a message is put into a coded form, it is known as a plaintext message.
	\item[Ciphertext] \hfill \\
	The sender of a message uses a cryptographic algorithm to encrypt the plaintext message and produce a ciphertext message.
\end{description}

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{cipher}
  \caption{Ciphertext Encryption}
\end{figure}

\begin{description}
	\item[Cryptographic key] \hfill \\
	A key is nothing more than a number (usually a very large binary number.  The key space is the range of numbers from 0 to 2n, where n is the bit size of the key. A 128-bit key can have a value from 0 to $2^{128}$.
	\item[One-Way Functions] \hfill \\
	A one-way function is a mathematical operation that easily produces output values for each possible combination of inputs but makes it impossible to retrieve the input values.
	\item[Reversability] \hfill \\
	Reversability is a very important property in cryptography because we could be able to undo the operation of encryption.
	\item[Nonce] \hfill \\
	The nonce must be a unique number each time it is used. Its used to make sure that a key is not re-used twice. A number that is only used one = number.
	\item[Initializaiton vector (IV)] \hfill \\
	An IV is a random bit string. It is the same length as the block size and is XORed with the message. IVs are used to create unique ciphertext every time the same message is encrypted using the same key
	\item[Confusion] \hfill \\
	Confusion occurs when the relationship between the plaintext and the key is so complicated that an attacker can’t merely continue altering the plaintext and analyzing the resulting ciphertext to determine the key. Substitution of bytes adds confusion.
	\item[Diffusion] \hfill \\
	Diffusion occurs when a change in the plaintext results in multiple changes spread throughout the ciphertext. A small change in the input leads to a big change on the output.
	\item[The Kerckhoffs's Principle] \hfill \\
	A cryptographic system should be secure even if everything about the system, except the key, is public knowledge. This principle makes algorithms known and public, allowing anyone to examine and test them. Public exposure may expose weaknesses more quickly, leading to the abandonment of insufficiently strong algorithms and quicker adoption of suitable ones. 
	\item[SP-Network] \hfill \\
	An SP-Network is an algorithm that uses repeated substitution and permutation operations. Substitution: Replacing bytes with others.  Permutation: Swapping bytes around. The substitutions and permutations are combined into a round. Rounds are then repeated many times.
\end{description}

\subsubsection{Caesear cipher}
One of the earliest known cipher systems was used by Julius Caesar to communicate with Cicero in Rome while he was conquering Europe. To encrypt a message, you simply shift each letter of the alphabet three places to the right. The Caesar cipher became known as the \textbf{ROT3 (or Rotate 3)} cipher. 

\subsubsection{The power of XOR}

\begin{minipage}{0,5\linewidth}
XOR is a binary operator between two values that returns true if either input or the other is true but not both. Extremely useful in cryptography. B is deciding whether A will change. Applying XOR twice, it reverses ist effect. Think of A as encrypting B, and then decrypting it again.
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\begin{center}
		\includegraphics[width=\linewidth]{xor}
	\end{center}
\end{minipage}

\subsubsection{The One Time pad}
We can design a cipher that uses XOR to encrypt and decrypt a message. Use a key that’s the same length as the message. XOR each message bit with each key bit. This supports perfect secrecy: if you take away the key, there is now way to find the message because there is no statistical mapping between the input and the output. This Cipher cannot be broken. But the one time pad is not practical. A 1GB file would need a 1GB key.
 
\subsection{Symmetric cryptography}
\begin{minipage}{0,5\linewidth}
 Symmetric key algorithms rely on a “shared secret” key that is distributed to all members who participate in the communications. The sender encrypts with the shared secret key and the receiver decrypts with it. When large-sized keys are used, symmetric encryption is very difficult to break. Symmetric key cryptography does not implement nonrepudiation. Because any communicating party can encrypt and decrypt messages with the shared secret key, there is no way to prove where a given message originated. Symmetric key cryptography does not implement message integrity. The major strength of symmetric key cryptography is the great speed at which it can operate. Symmetric key encryption is very fast, often 1'000 to 10'000 times faster than asymmetric algorithms.
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\includegraphics[width=\linewidth]{symetriccryptography}
\end{minipage}

\subsubsection{Stream ciphers}
We can approximate a one-time pad by generating an infinite pseudo-random keystream. Stream ciphers work on messages of any length. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{streamcipher}
  \caption{Stream Cipher}
\end{figure}

\begin{minipage}{0,5\linewidth}
\begin{description}
	\item[+] 
	Encryption of long continuous streams, possibly of unknown lengt.
	\item[+] 
	Extremely fast with a low memory footprint, ideal for low-power devices.
	\item[+] 
 	If designed well, it can seek to any location in the stream.
\end{description}
\end{minipage}
\begin{minipage}{0,5\linewidth}
\begin{description}
	\item[-] 
	The keystream must appear statistically random.
	\item[-] 
	You must never reuse a key + nonce.
	\item[-] 
	Stream ciphers do not protect the ciphertext (= no guaranteed integrity)
\end{description}
\end{minipage}

\subsubsection{Block Ciphers}
Block ciphers take an input of a fixed size and return an output of the same size. Block ciphers attempt to hide the transformation from message to ciphertext through confusion and diffusion. Most of the block ciphers are SP-Networks. The Advanced Encryption Standard (AES) is an SP-Network. 

\begin{minipage}{0,5\linewidth}
	\subsubsection{Basic substitution box}
	\center
	\includegraphics[width=\linewidth]{substitutionbox}
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\subsubsection{Basic permutation box}
	\includegraphics[width=\linewidth]{premutationbox} 
\end{minipage} 


\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{spnetwork}
  \caption{SP-Network}
\end{figure}

\subsubsection{Advanced Encryption Standard}
\begin{minipage}{0,5\linewidth}
A standard built around the Rijndael algorithm. Superseed DES as a standard in 2002. SP-Network with a 128-bit block size. Key length of 128, 192 or 256-bits. 10,12 or 14 rounds. Each round: SubBytes, Shiftrows, MixColumns, KeyAddition.
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\includegraphics[width=\linewidth]{aes}
\end{minipage}

\subsection{Mode of operation for block ciphers}
Realistically, messages of exactly 128-bits are pretty unlikely. A mode of operation is the combination of multiple instances of block encryption into a usable protocol. There are three modes of operation.

\subsubsection{Electronic Code Book (ECB)}
\begin{minipage}{0,5\linewidth}
Just encrypts each block after another. Is weak to redundant data divulging patterns. ECB are not recommended. 
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\includegraphics[width=\linewidth]{ecb} 
\end{minipage}

\subsubsection{Cipher Block Chaining (CBC)}
\begin{minipage}{0,5\linewidth}
XOR the output of each cipher block with the next output. Not parallelizable. It is better than ECB but not perfect.
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\includegraphics[width=\linewidth]{cbc} 
\end{minipage}

\subsubsection{Counter Mode (CTR)}
\begin{minipage}{0,5\linewidth}
%todo Add CTR mode
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\includegraphics[width=\linewidth]{ctr} 
\end{minipage}

\subsection{Diffie-Hellman}
We need to share a key in order to begin encryption. How do we establish a shared secret key? With Diffie-Hellman, two parties can jointly agree a shared secret over an insecure channel. Every communication handshake in the internet is powered by Diffie Hellman handshake. (TLS) 

\textbf{The discrete Logarithms Problem} \\
$3^{x}\; mod \; 7 = 1$ what is x? \\
This leaves us having to brute force the answer. 

\begin{enumerate}
	\item Alice and Bob agree on a set of base parameters 
	Alice and Bob agree on a large prime p, and a generator g (also a prime) tat is a primitive root of p. p is very big (usually 2048 or 4096 bits).
	\item Alice and Bob select random numbers as their private keys Alice chooses a private value a at random. Bob chooses a private value b at random. The private numbers are just values between 1 and p. This number is a 2048 bits number so the chances that you are guessing Alice's private key is astronomically low (so essentially 0). Really important: They never tell eachother that private number.
	\item Alice and Bob each calculate a public key.
	Alice calculates $g^{a} mod p$ and Bob calculates  $g^{b} mod p$. They create a public version of their key by using g and n to mathematically hide the private version.
	\item They swap these public keys over the wire. 
	\item They combine their private key with the other's public key, creating the shared key. Alice computes $(g^{b})^{a}mod p$. Bob computes $(g^{a})^{b}mod p$. $(g^{ab})mod p$ is the shared key and its going to end up to be exactly the same for Alice and Bob.
	\item The shared secret is usually called the pre-master secret. It's used to dervice session keys.
\end{enumerate}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{diffiehellmann}
  \caption{Diffie-Hellmann}
\end{figure}

\subsubsection{Elliptic Curve Cryptography}
\begin{minipage}{0,5\linewidth}
Elliptic curves are a drop-in replacement for the mathematics underpinning regular Diffie-Hellman. Elliptic curve is a two dimension curve. $y2 = x3 + ax + b$. The private key is a number and the public key is composed of two numbers(x,y).
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\center
	\includegraphics[width=\linewidth]{dhc}
\end{minipage}

\subsection{Ephemeral Mode}
In most protocols, running Diffie-Hellman in ephemeral mode forces a new key exchange for every new session. This is called perfect forwarding secrecy. DH in ephemeral mode means a new DH everytime, not necessarily every message, but pretty often.
